/*
 *  3-WAY
 */

#include <stdio.h>

#define STRT_E  0x0b0b          /* ŏ̈ÍpEh萔 */
#define STRT_D  0xb1b1          /* ŏ̕pEh萔 */
#define NMBR    11              /* Eh11 */

/* ̃vÔ long == 32rbg ̂Ƃ̂ */
typedef unsigned long int word32;

typedef unsigned long u4;
typedef unsigned char u1;

typedef struct {
    u4 k[3], ki[3], ercon[NMBR+1], drcon[NMBR+1];
} twy_ctx;

/* ӁFÍƕ̓ubN̑SΏۂɂĂB
 * -- ubNpfBÔ͌Ăяo̐ӔCB
 * ׂĂ̂܂Ƃ܂Í͂̌ĂяołECB[hōsB
 * ȊÕ[h͂ƊȒPɒǉł邾낤B
 */

/* jFReLXg */
/* ׂĂ̌Ă͂܂f[^̃ReLXgꂢɂ */
void twy_destroy(twy_ctx *);

/* ÍFReLXgAf[^ubNւ̃|C^AubN */
void twy_enc(twy_ctx *, u4 *, int);

/* FReLXgAf[^ubNւ̃|C^AubN */
void twy_dec(twy_ctx *, u4 *, int);

/* FReLXgAf[^ւ̃|C^ */
void twy_key(twy_ctx *, u4 *);

/* ACCODE----------------------------------------------------------- */
/* ACR[h̃vg^Cvƍ\̂͂܂ŁB                        */
/* ----------------------------------------------------------------- */

/* a ̃rbg𔽓] */
void mu(word32 *a)
{
    int i;
    word32 b[3];

    b[0] = b[1] = b[2] = 0;
    for (i = 0; i < 32; i++) {
        b[0] <<= 1; b[1] <<= 1; b[2] <<= 1;
        if (a[0] & 1)
            b[2] |= 1;
        if (a[1] & 1)
            b[1] |= 1;
        if (a[2] & 1)
            b[0] |= 1;
        a[0] >>= 1 ; a[1] >>= 1 ; a[2] >>= 1 ;
    }

    a[0] = b[0]; a[1] = b[1]; a[2] = b[2];
}

/* ^ő */
void gamma(word32 *a)
{
    word32 b[3] ;

    b[0] = a[0] ^ (a[1] | (~a[2]));
    b[1] = a[1] ^ (a[2] | (~a[0]));
    b[2] = a[2] ^ (a[0] | (~a[1]));

    a[0] = b[0]; a[1] = b[1]; a[2] = b[2];
}

/* `ő */
void theta(word32 *a)
{
    word32 b[3];

    b[0] = a[0] ^ (a[0]>>16) ^ (a[1]<<16) ^     (a[1]>>16) ^ (a[2]<<16) ^
                  (a[1]>>24) ^ (a[2]<<8)  ^     (a[2]>>8)  ^ (a[0]<<24) ^
                  (a[2]>>16) ^ (a[0]<<16) ^     (a[2]>>24) ^ (a[0]<<8);
    b[1] = a[1] ^ (a[1]>>16) ^ (a[2]<<16) ^     (a[2]>>16) ^ (a[0]<<16) ^
                  (a[2]>>24) ^ (a[0]<<8)  ^     (a[0]>>8)  ^ (a[1]<<24) ^
                  (a[0]>>16) ^ (a[1]<<16) ^     (a[0]>>24) ^ (a[1]<<8);
    b[2] = a[2] ^ (a[2]>>16) ^ (a[0]<<16) ^     (a[0]>>16) ^ (a[1]<<16) ^
                  (a[0]>>24) ^ (a[1]<<8)  ^     (a[1]>>8)  ^ (a[2]<<24) ^
                  (a[1]>>16) ^ (a[2]<<16) ^     (a[1]>>24) ^ (a[2]<<8);

    a[0] = b[0]; a[1] = b[1]; a[2] = b[2];
}

void pi_1(word32 *a)
{
    a[0] = (a[0]>>10) ^ (a[0]<<22);
    a[2] = (a[2]<<1)  ^ (a[2]>>31);
}

void pi_2(word32 *a)
{
    a[0] = (a[0]<<1)  ^ (a[0]>>31);
    a[2] = (a[2]>>10) ^ (a[2]<<22);
}

/* Eh֐ */
void rho(word32 *a)
{
    theta(a);
    pi_1(a);
    gamma(a);
    pi_2(a);
}

/* Eh萔𐶐 */
void rndcon_gen(word32 strt, word32 *rtab)
{
    int i;

    for (i = 0; i <= NMBR; i++) {
        rtab[i] = strt;
        strt <<= 1;
        if (strt & 0x10000)
            strt ^= 0x11011;
    }
}

/* ÍFĂяo̗vɂ킹邽߂ɏCĂ */
void encrypt(twy_ctx *c, word32 *a)
{
    int i;

    for (i = 0; i < NMBR; i++) {
        a[0] ^= c->k[0] ^ (c->ercon[i]<<16);
        a[1] ^= c->k[1];
        a[2] ^= c->k[2] ^ c->ercon[i];
        rho(a);
    }
    a[0] ^= c->k[0] ^ (c->ercon[NMBR]<<16);
    a[1] ^= c->k[1];
    a[2] ^= c->k[2] ^ c->ercon[NMBR];

    theta(a);
}

/* FĂяo̗vɂ킹邽߂ɏCĂ */
void decrypt(twy_ctx *c, word32 *a)
{
    int i;

    mu(a);
    for (i = 0; i < NMBR; i++) {
        a[0] ^= c->ki[0] ^ (c->drcon[i]<<16);
        a[1] ^= c->ki[1];
        a[2] ^= c->ki[2] ^ c->drcon[i];
        rho(a);
    }
    a[0] ^= c->ki[0] ^ (c->drcon[NMBR]<<16);
    a[1] ^= c->ki[1];
    a[2] ^= c->ki[2] ^ c->drcon[NMBR];

    theta(a);
    mu(a);
}

void twy_key(twy_ctx *c, u4 *key)
{
    c->ki[0] = c->k[0] = key[0];
    c->ki[1] = c->k[1] = key[1];
    c->ki[2] = c->k[2] = key[2];

    theta(c->ki);
    mu(c->ki);

    rndcon_gen(STRT_E, c->ercon);
    rndcon_gen(STRT_D, c->drcon);
}

/* ECB[hňÍ */
void twy_enc(twy_ctx *c, u4 *data, int blkcnt)
{
    u4 *d;
    int i;

    d = data;
    for (i = 0; i < blkcnt; i++) {
        encrypt(c, d);
        d += 3;
    }
}

/* ECB[hŕ */
void twy_dec(twy_ctx *c, u4 *data, int blkcnt)
{
    u4 *d;
    int i;

    d = data;
    for (i = 0; i < blkcnt; i++) {
        decrypt(c, d);
        d += 3;
    }
}

/* ̑OɁAƂ܂lꂢɏĂ */
void twy_destroy(twy_ctx *c)
{
    int i;

    for(i = 0; i < 3; i++)
        c->k[i] = c->ki[i] = 0;
}

void printvec(char *chrs, word32 *d)
{
    printf("%20s : %08lx %08lx %08lx \n", chrs, d[2], d[1], d[0]);
}

int main(int argc, char *argv[])
{
    twy_ctx gc;
    word32 a[9], k[3];
    int i;

    /* eXgpxNg1 */
    k[0] = k[1] = k[2] = 0;
    a[0] = a[1] = a[2] = 1;
    twy_key(&gc, k);

    printf("**********\n");
    printvec("KEY = ", k);      /*  */
    printvec("PLAIN = ", a);    /*  */
    encrypt(&gc, a);
    printvec("CIPHER = ", a);   /* Í */

    /* eXgpxNg2 */
    k[0] = 6; k[1] = 5; k[2] = 4;
    a[0] = 3; a[1] = 2; a[2] = 1;
    twy_key(&gc, k);

    printf("**********\n");
    printvec("KEY = ", k);      /*  */
    printvec("PLAIN = ", a);    /*  */
    encrypt(&gc, a);
    printvec("CIPHER = ", a);   /* Í */

    /* eXgpxNg3 */
    k[2] = 0xbcdef012; k[1] = 0x456789ab; k[0] = 0xdef01234;
    a[2] = 0x01234567; a[1] = 0x9abcdef0; a[0] = 0x23456789;
    twy_key(&gc, k);

    printf("**********\n");
    printvec("KEY = ", k);      /*  */
    printvec("PLAIN = ", a);    /*  */
    encrypt(&gc, a);
    printvec("CIPHER = ", a);   /* Í */

    /* eXgpxNg4 */
    k[2] = 0xcab920cd; k[1] = 0xd6144138; k[0] = 0xd2f05b5e;
    a[2] = 0xad21ecf7; a[1] = 0x83ae9dc4; a[0] = 0x4059c76e;
    twy_key(&gc, k);

    printf("**********\n");
    printvec("KEY = ", k);      /*  */
    printvec("PLAIN = ", a);    /*  */
    encrypt(&gc, a);
    printvec("CIPHER = ", a);   /* Í */

    /*  eXgp̒l:
     *
     *          : 00000000 00000000 00000000
     *        : 00000001 00000001 00000001
     *  Í    : ad21ecf7 83ae9dc4 4059c76e
     *
     *          : 00000004 00000005 00000006
     *        : 00000001 00000002 00000003
     *  Í    : cab920cd d6144138 d2f05b5e
     *
     *          : bcdef012 456789ab def01234
     *        : 01234567 9abcdef0 23456789
     *  Í    : 7cdb76b2 9cdddb6d 0aa55dbb
     *
     *          : cab920cd d6144138 d2f05b5e
     *        : ad21ecf7 83ae9dc4 4059c76e
     *  Í    : 15b155ed 6b13f17c 478ea871
     */

    /* Í/̃eXg */
    for (i = 0; i < 9; i++) {
        a[i] = i;
    }

    twy_enc(&gc, a, 3);

    for (i = 0; i < 9; i += 3) {
        /* ubN %01d ͎̂悤ɈÍ */
        printf("Block %01d encrypts to %08lx %08lx %08lx\n",
               i/3, a[i], a[i+1], a[i+2]);
    }

    twy_dec(&gc, a, 2);
    twy_dec(&gc, a+6, 1);

    for (i = 0; i < 9; i += 3) {
        /* ubN %01d ͎̂悤ɕ */
        printf("Block %01d decrypts to %08lx %08lx %08lx\n",
               i/3, a[i], a[i+1], a[i+2]);
    }

    return 0;
}
